/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.
lSchedCount
  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with su~/linux_projects/RISC_CPU_64_Multi_Thread_Version_0.5/Debug/src/ch restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.
thread_h
 *****************************************************************************/

/*****************************************************************************
 
  dcache.cpp -- Data Cache Unit.
 
  Original Author: Martin Wang, Synopsys, Inc.
 
 *****************************************************************************/
 
/*****************************************************************************
 
  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.
 
      Name, Affiliation, Date:
  Description of Modification:
 
 *****************************************************************************/


#include "src/systemc.h"
#include "dcache.h"
#include "threads.h"

#include "work_load.h"
#include "SystemC/os_systemc.h"
#include <xdc/std.h>
#include <xdc/runtime/Error.h>
#include <xdc/runtime/System.h>
extern "C" bool mainDcacheReadSystem_printflag ; 
extern "C" bool mainDcacheWriteSystem_printflag ;


unsigned int address ; 
unsigned int  dcache_dest_tmp  ;
unsigned dmemory[ dcachesize];	 				// data memory
unsigned dsmemory[ dcachesize];	 				// data state memory
unsigned dtagmemory[ dcachesize];	 				// tag memory
unsigned int 	reg_tmp;


  void dcache_init_data()  
{
	FILE *fp = fopen("dcache","r");
	int size=0;
	int i=0;
	int mem_word;
  
	System_printf("** ALERT ** DCU: initialize Data Cache\n");
	while (fscanf(fp,"%x", &mem_word) != EOF) 
	{
		dmemory[size] = mem_word;
		dsmemory[size] = 0;
		dtagmemory[size] = size;
		size++;
	}
	for (i=size; i< dcachesize; i++) 
	{
		dtagmemory[i] = 0xdeadbeef;
		dmemory[i] = 0xdeadbeef;
		dsmemory[i] = 0;
	}
  
  reg_tmp = 0 ; 
  dcache_dest_tmp   = 0 ; 
}






void DachePrintRead ()
 {
	if (mainDcacheReadSystem_printflag == true ) 
	{

		mainDcacheReadSystem_printflag = false ; 
		System_printf( "\t------------------------------- \n" ) ;
		System_printf("\tData Cache Unit :ld %0x<-mem[%0x]->R%0x\n", dmemory[address], address,dcache_dest_tmp );
		System_printf("\tData Cache Unit :Tag = 0x%x", dtagmemory[address]);
		if (dsmemory[address] == 3) 
		{
			System_printf(" (M)");
		} else 
			if (dsmemory[address] == 2)
			{
				System_printf(" (E)");
			} else 
				if (dsmemory[address] == 1) 
				{
					System_printf(" (S)");
				} else 
					if (dsmemory[address] == 0)
					{
						System_printf(" (I)");
					} else 
						System_printf(" (X)");
	}

 }
 void DcachePrintWrite ()
 {
	 if (	mainDcacheWriteSystem_printflag == true ) 
		{
			mainDcacheWriteSystem_printflag = false ; 
			System_printf( "\t------------------------------- \n" ) ;
			System_printf("\tData Cache Unit: St %x->mem[%0x]", dmemory[address], address);
			System_printf("\t\t\t\t\t\t\tDCU :Tag = 0x%x", dtagmemory[address]);
			System_printf( "\t\t\t\t\t\t\t-------------------------------\n" );
		
	 }
 }

void dcache::entry_dcache()
{
 
	dcache_init_data () ; 
	work_load (INFINITE, ThreadDcacheID)  ;
	sc_module::wait(); 
	 while (true) {
		
         while (cs.read() ==false ) 
		 {
		  work_load (INFINITE, ThreadDcacheID)  ; 
		  sc_module::wait(); // sc_module::wait();  ;
		 }
     	dcache_dest_tmp  = dest.read();
        reg_tmp = dest.read();
    	address = addr.read();
    	if (we.read() == true)  		// Write operation
		{
      		work_load (INFINITE, ThreadDcacheID)  ; 
			sc_module::wait();  ;
      		out_valid.write(false);
      		dmemory[address] = datain.read();
      		dsmemory[address] = statein.read();
      		dtagmemory[address] = addr.read();
			//mainDcacheWriteSystem_printflag = TRUE ;
			work_load (INFINITE, ThreadDcacheID)  ;  		
			sc_module::wait();  ;
    	}
    	else  					// Read operation
		{
			work_load (INFINITE, ThreadDcacheID)  ; 
			sc_module::wait();  ;
        	dataout.write(dmemory[address]);
			stateout.write(dsmemory[address]);
			destout.write(dcache_dest_tmp );
        	out_valid.write(true);
	
			mainDcacheReadSystem_printflag = true ; 
			work_load (INFINITE, ThreadDcacheID)  ; 
        	sc_module::wait();  ;
        	out_valid.write(false);
			work_load (INFINITE, ThreadDcacheID)  ; 
			sc_module::wait();
    	}    
  }
} // end of entry function
