/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.

  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with such restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.

 *****************************************************************************/

/*****************************************************************************
 
  icache.cpp -- Instruction Cache Unit.
 
  Original Author: Martin Wang, Synopsys, Inc.
 
 *****************************************************************************/
 
/*****************************************************************************
 
  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.
 
      Name, Affiliation, Date: Gene Bushuyev, Synopsys, Inc.
  Description of Modification: - bug - read/write outside of allocated memory
 
      Name, Affiliation, Date:
  Description of Modification:

 *****************************************************************************/

#include "src/systemc.h"
#include "icache.h"
#include "directive.h"
#include "work_load.h"
#include "threads.h"
#include "SystemC/os_systemc.h"
#include <xdc/std.h>
#include <xdc/runtime/Error.h>
#include <xdc/runtime/System.h>
extern "C" bool  mainPrintIcacheFlag ; 
extern "C" bool mainPrintIcacheAlertResetFlag ; 
extern "C" bool mainPrintIcachePidFlag ;
extern "C" bool mainIcacheOutOfRangeFlag ;
extern "C" bool mainPrintPerformanceFlag ;
signed int icache_pid;	

void IcachePrintAlertReset ()
{
	if ( mainPrintIcacheAlertResetFlag == true )
	{

		mainPrintIcacheAlertResetFlag = false ; 
		System_printf("Instruction Cache Unit ALERT: *********************************************************************\n");
		System_printf("         : *****************************AFTER RESET*****************************\n");
		System_printf("Instruction Cache Unit ALERT: *********************************************************************\n");
	}
}


 				// process ID
 void  IcachePrintIcachePid() 
 {
	 if (	mainPrintIcachePidFlag == true ) 
	 {
				mainPrintIcachePidFlag = false ;
				System_printf("------------------------\n");
				System_printf("Instruction Cache Unit: PID = [%0x]", icache_pid); 
	 }
 }
 void IcachePrintOutOfRange()
{
	if ( mainIcacheOutOfRangeFlag == true ) 
	{
		mainIcacheOutOfRangeFlag = false ;  
 
		System_printf("ICU ALERT: **MEMORY OUT OF RANGE**\n");

		System_printf("\n\n\n\n\n////////////////////////////////////////////////////////////////////////////////\n");
		mainPrintPerformanceFlag = true ; 
	}
}

   	unsigned icmemory [IcacheCodeSize ];
  	unsigned ictagmemory[IcacheCodeSize ];
	int size=0;
	int mem_word;
 void icache_init_var ()
 {
	// Initialize instruction icmemory from external file


	FILE *fp = fopen("icache","r");
	
	for (size = 0; size < IcacheCodeSize; size++) 
	{	// initialize bad data
		icmemory[size] = 0xeeeeeeee;
		ictagmemory[size] = 0xeeeeeeee;
	}
	size = 0;
	while (fscanf(fp,"%x", &mem_word) != EOF) 
	{
		icmemory[size] = mem_word;
		ictagmemory[size] = size;
		size++;
	}
  }

void icache::entry_icache()
{

unsigned int 	address;
icache_init_var (); 
//os_systemcWaitThreadSync() ;
sc_module::wait();

 while (true) 
 {
   	mainPrintIcacheFlag = false ; 
	while (cs.read() == false ) 
		{
			work_load ( INFINITE, ThreadIcacheID  ) ;
			sc_module::wait();
		}
    	
    address = addr.read();
	if (address == BOOT_LENGTH) 
	{
		mainPrintIcacheAlertResetFlag = true ; 
	}
	if (address >= BOOT_LENGTH)
	{
		if (ld_valid.read() == true) 
		{
		    
			icache_pid	= ld_data.read();
				
			mainPrintIcacheFlag = true ;
			mainPrintIcachePidFlag = true ;
      	work_load ( INFINITE, ThreadIcacheID ) ;
      	sc_module::wait() ;
      work_load ( INFINITE, ThreadIcacheID ) ;
      sc_module::wait() ;
		}
    	if (we.read() == true) { // Write operation
      		work_load ( INFINITE, ThreadIcacheID ) ;
      		sc_module::wait();
		if (address < IcacheCodeSize )
		{
			icmemory[address] = datain.read();
			mainPrintIcacheFlag = true ;
		}
		else
		{
			mainPrintIcacheFlag = true ;
			mainPrintIcacheAlertResetFlag = true ; 

		}
   	work_load ( INFINITE, ThreadIcacheID ) ;
   	sc_module::wait ();
	}
	else // Read operation
	{ 
	work_load ( INFINITE, ThreadIcacheID ) ; 
	sc_module::wait(); // Introduce delay needed
		if (address >= IcacheCodeSize )
		{
			dataout.write(0xffffffff);
			mainIcacheOutOfRangeFlag = true ;
	
		}
        else
       	  dataout.write(icmemory[address]);

		icache_valid.write(true);
	work_load ( INFINITE, ThreadIcacheID ) ; 
	sc_module::wait() ;
	icache_valid.write(false);
   	work_load ( INFINITE, ThreadIcacheID ) ; 
	sc_module::wait();
	}    
	}
 }

 
} // End of entry function
