#ifndef OS_SYSTEMC_H
#define OS_SYSTEMC_H
#define ThreadNum 256
#define INFINITE -1

#include "ti/sysbios/BIOS.h"
#include "ti/sysbios/knl/Task.h"
#include "ti/sysbios/knl/Semaphore.h"
#include "ti/sysbios/knl/Event.h"

#include "sysc/kernel/sc_process.h"
#include "sysc/kernel/sc_process_handle.h"
#include "sysc/kernel/sc_thread_process.h"

extern "C" Semaphore_Handle os_systemc_hThreadSemaphoresArray[ThreadNum];
extern "C" UInt os_systemc_hThreadEventsArray[ThreadNum];
extern "C" Task_Handle os_systemc_hThreadArray[ThreadNum];
extern "C" unsigned long os_systemc_dwThreadIDArray[ThreadNum];

extern "C" sc_core::sc_thread_handle os_systemc_HandleCThreadArray[ThreadNum];
extern "C" sc_core::sc_thread_handle os_systemc_HandleThreadArray[ThreadNum];

extern "C" sc_core::sc_method_handle os_systemc_HandleMThreadArray[ThreadNum];

extern "C" sc_core::SC_ENTRY_FUNC os_systemc_semantics_method_p[ThreadNum];

extern "C" sc_core::sc_simcontext* os_systemc_sc_simcontext_ptr[ThreadNum];
extern "C" sc_core::sc_port_registry* os_systemc_sc_port_registry_ptr[ThreadNum];

extern "C" sc_core::sc_module* os_systemc_module_registry_ptr[ThreadNum];
extern "C" bool os_systemc_ThreadInitFlag[ThreadNum];
extern "C" long os_systemc_m_lThreadWaitCount[ThreadNum];
extern "C" long os_systemc_m_lThreadWorkCount[ThreadNum];

extern "C" int os_systemc_int_ActualThreadNum;


void os_systemc_set_ThreadEvent(int id);
void os_systemcWait(long duration);
void os_systemc_ThreadWaitCycles(long thread_wait_cycles);
int os_systemc_GetCurrentThreadIndex();
int os_systemc_map_method_or_cthread_to_osthread(
		sc_core::SC_ENTRY_FUNC method_p);
void os_systemc_wait_for_all_threads_termination();
void os_systemc_setSemaphore(Semaphore_Handle Event);
void os_systemcWaitThreadSync();
bool os_systemc_ThreadCheckInit();

#endif 
